# Copyright (C) 2001-2003 Tuomo Makinen (tmakinen@pp.htv.fi)
# Licensed under the terms of the GNU General Public License
# client.py v. 0.1.4

import os
import md5
import string

# Trusted certificates for verification purposes
if os.name == "posix":
    CA_CERTS = os.environ["HOME"] + "/.rnmapcerts"
else:
    CA_CERTS = "rnmapcerts"

CRLF = "\r\n"
RECVERR = "recv(): error"
SENDERR = "send(): error"
PROTOCOL_ERROR = "Protocol error"
INTERRUPT_SCAN = "102"
PROTOCOL_CODES = {"401" : "Access denied",
                  "402" : "Operation failed",
                  "403" : "Protocol error",
                  "404" : "Operation denied",
                  }

def signal_handler_sigalrm(signum, frame):
    # Interrupt connect()
    return

def digest_cert(asn1cert):
    digest = md5.new(asn1cert).digest()
    return string.upper("%02x:" * len(digest) % tuple(map(ord, digest)))[:-1]

def store_certificate(cert):
    try:
        fp = open(CA_CERTS, "a")
        fp.write(cert)
    except IOError:
        return -1
    fp.close()
    
