#!/usr/bin/env python

# Rnmap userdel v. 0.1.3
#
# Copyright (C) 2001,2002 Tuomo Makinen (tmakinen@pp.htv.fi)
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

import os
import sys
import string
import fcntl

# Rnmap conf directory
try:
    Conf_dir = os.environ["RNMAPDIR"]
except KeyError:
    Conf_dir = os.getcwd()

Ulist_file = os.path.join(Conf_dir, "users.list")
Rnmapdpid = os.path.join(Conf_dir, "rnmapd.pid")

def main():
    try:
        uname = sys.argv[1]
    except:
        sys.stderr.write("usage: rnmap-userdel name\n")
        sys.exit()
    else:
        remove_user(uname)
    sys.exit()
    
def remove_user(uname):
    try:
        fp = open(Ulist_file)
    except IOError, e:
        sys.stderr.write("Can't modify users.list: " + e[1] + "\n")
        sys.exit(1)
    else:
        fcntl.flock(fp.fileno(), fcntl.LOCK_SH)
        userlist = fp.readlines()
        fcntl.flock(fp.fileno(), fcntl.LOCK_UN)
        fp.close()
        uindex = {}
        for j in xrange(len(userlist)):
            luname = string.split(userlist[j], ":")
            uindex[luname[0]] = j
        if uindex.has_key(uname):
            userlist.pop(uindex[uname])
            rewrite_list(userlist)
            sys.stdout.write("\nUser " + uname + " succesfully deleted.\n")
        else:
            sys.stderr.write("Can't find user: " + uname + "\n")
            sys.exit(1)
            
def rewrite_list(userlist):
    try:
        fp = open(Ulist_file, 'w')
    except IOError, e:
        sys.stderr.write("Can't write to users.list: " + e[1] + "\n")
        sys.exit(1)
    else:
        fcntl.flock(fp.fileno(), fcntl.LOCK_EX)
        for i in xrange(len(userlist)):
            fp.write(userlist[i])
        fcntl.flock(fp.fileno(), fcntl.LOCK_UN)
        fp.close()
        restart()
            
def restart():
    try:
        pid = open(Rnmapdpid).read()
        pid = string.atoi(pid)
    except (IOError, ValueError):
        pass
    else:
        print "\nSending HUP signal to rnmapd."
        try:
            os.kill(pid, 1)
        except OSError, e:
            sys.stderr.write(e[1] + '\n')
    print "\nAll done."

os.umask(0066)
main()
